Create report
curl --request POST \
--url https://api.nops.io/v1/reports \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"name": "AWS Spend by Account",
"scope": "private",
"config": {
"dateRange": {
"start": "2026-05-31",
"end": "2026-06-29"
},
"groupBy": "product_product_name",
"costType": "line_item_unblended_cost",
"granularity": "day",
"filters": []
}
}
'import requests
url = "https://api.nops.io/v1/reports"
payload = {
"name": "AWS Spend by Account",
"scope": "private",
"config": {
"dateRange": {
"start": "2026-05-31",
"end": "2026-06-29"
},
"groupBy": "product_product_name",
"costType": "line_item_unblended_cost",
"granularity": "day",
"filters": []
}
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
name: 'AWS Spend by Account',
scope: 'private',
config: {
dateRange: {start: '2026-05-31', end: '2026-06-29'},
groupBy: 'product_product_name',
costType: 'line_item_unblended_cost',
granularity: 'day',
filters: []
}
})
};
fetch('https://api.nops.io/v1/reports', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.nops.io/v1/reports"
payload := strings.NewReader("{\n \"name\": \"AWS Spend by Account\",\n \"scope\": \"private\",\n \"config\": {\n \"dateRange\": {\n \"start\": \"2026-05-31\",\n \"end\": \"2026-06-29\"\n },\n \"groupBy\": \"product_product_name\",\n \"costType\": \"line_item_unblended_cost\",\n \"granularity\": \"day\",\n \"filters\": []\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}{
"data": {
"report": {
"id": "report-1",
"name": "AWS Spend by Account",
"scope": "private",
"config": {
"dateRange": {
"start": "2026-05-31",
"end": "2026-06-29"
},
"groupBy": "product_product_name",
"costType": "line_item_unblended_cost",
"granularity": "day",
"filters": []
},
"organizationId": "org-1",
"nopsClientId": 42,
"creatorId": "user-1",
"createdAt": "2026-07-17T12:00:00.000Z",
"updatedAt": "2026-07-17T12:00:00.000Z",
"creator": {
"id": "user-1",
"firstName": "FinOps",
"lastName": "Analyst",
"email": "finops@example.com"
}
}
}
}{
"error": {
"code": "forbidden_scope",
"message": "API key is missing required scope: budgets:write",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "forbidden_scope",
"message": "API key is missing required scope: budgets:write",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Reports
Create report
POST
https://api.nops.io
/
v1
/
reports
Create report
curl --request POST \
--url https://api.nops.io/v1/reports \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"name": "AWS Spend by Account",
"scope": "private",
"config": {
"dateRange": {
"start": "2026-05-31",
"end": "2026-06-29"
},
"groupBy": "product_product_name",
"costType": "line_item_unblended_cost",
"granularity": "day",
"filters": []
}
}
'import requests
url = "https://api.nops.io/v1/reports"
payload = {
"name": "AWS Spend by Account",
"scope": "private",
"config": {
"dateRange": {
"start": "2026-05-31",
"end": "2026-06-29"
},
"groupBy": "product_product_name",
"costType": "line_item_unblended_cost",
"granularity": "day",
"filters": []
}
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
name: 'AWS Spend by Account',
scope: 'private',
config: {
dateRange: {start: '2026-05-31', end: '2026-06-29'},
groupBy: 'product_product_name',
costType: 'line_item_unblended_cost',
granularity: 'day',
filters: []
}
})
};
fetch('https://api.nops.io/v1/reports', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.nops.io/v1/reports"
payload := strings.NewReader("{\n \"name\": \"AWS Spend by Account\",\n \"scope\": \"private\",\n \"config\": {\n \"dateRange\": {\n \"start\": \"2026-05-31\",\n \"end\": \"2026-06-29\"\n },\n \"groupBy\": \"product_product_name\",\n \"costType\": \"line_item_unblended_cost\",\n \"granularity\": \"day\",\n \"filters\": []\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}{
"data": {
"report": {
"id": "report-1",
"name": "AWS Spend by Account",
"scope": "private",
"config": {
"dateRange": {
"start": "2026-05-31",
"end": "2026-06-29"
},
"groupBy": "product_product_name",
"costType": "line_item_unblended_cost",
"granularity": "day",
"filters": []
},
"organizationId": "org-1",
"nopsClientId": 42,
"creatorId": "user-1",
"createdAt": "2026-07-17T12:00:00.000Z",
"updatedAt": "2026-07-17T12:00:00.000Z",
"creator": {
"id": "user-1",
"firstName": "FinOps",
"lastName": "Analyst",
"email": "finops@example.com"
}
}
}
}{
"error": {
"code": "forbidden_scope",
"message": "API key is missing required scope: budgets:write",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "forbidden_scope",
"message": "API key is missing required scope: budgets:write",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Authorizations
API key from Settings → Security → API Keys. Pass as Authorization: Bearer YOUR_API_KEY.
Headers
Unique key for safe retries on write requests (required, max 64 characters).
Maximum string length:
64Body
application/json
JSON request body
Response
Create report
JSON object
Was this page helpful?
⌘I